;(function($) {

    var ns = 'simpleCaptcha';

    $.fn.simpleCaptcha = function(o) {
        var n = $(this);
        var c;
        o = (o)?o:{};

        if (n.length === 1 && n.hasClass(ns) && n.data(ns) && o && o.length) {
            c = n.data(ns);
            if (c && o === 'refresh') {
                c.refresh();

            } else if (c) {
                return c[o];
            }

        } else if (!o.node && n.length) {
            o.node = n.filter(':first');
        }

        if (!c && o.node) {
            c = new $.jk.SimpleCaptcha(o);
            c.loadImageData(function(d) { if (d) { c.addImagesToUI(); } });
        }

        if (!c) { n.trigger('error.'+ns, ['No node provided for the simpleCaptcha UI']); }

        return n;
    };


    if (!$.jk) { $.jk = {}; }
    $.jk.SimpleCaptcha = function(o) {
        var t = this;
        o = (o)?o:{};
        t.data = {};

        if (o.numImages && (!Number(o.numImages) || o.numImages < 1)) { o.numImages = t.numImages; }
        $.extend(t, ((o)?o:{}));
        t.allowRefresh = !!t.allowRefresh;

        var n;
        t.node = $( ((o.node)?o.node:null) );
        if (t.node && t.node.length === 1){
            n = t.node;
        } else {
            return t;
        }

        n.addClass(ns)
            .html('')
            .append(
            "<div class='"+t.introClass+"'>"+t.introText+"</div>"+
            "<div class='"+t.imageBoxClass+"'></div>"+
            "<input class='"+ns+"Input' name='"+t.inputName+"' type='hidden' value='' />"+
            "<input name='captcha_id' type='hidden' value='"+ t.id+"'/>"
        )
            .data(ns, t)
            .find('.'+t.imageBoxClass)
            .on('click', 'img.'+t.imageClass, function(e) {
                e.preventDefault();
                n.find('img.'+t.imageClass).removeClass(ns+'Selected');
                var hash = $(this).addClass(ns+'Selected').attr('data-hash');
                n.find('.'+ns+"Input").val(hash);

                n.trigger('select.'+ns, [t, hash]);
                return false;
            })
            .on('keyup', 'img.'+t.imageClass, function(e) {
                if (e.which == 13 || e.which == 32) {
                    $(this).click();
                }
            });

        if (t.allowRefresh) {
            var b = $(t.refreshButton);
            n.find('.'+t.introClass)
                .after("<div class='"+t.refreshClass+"' />")
                .siblings('.'+t.refreshClass)
                .append(b);
            b.on('click', function(e) {
                e.preventDefault();
                t.refresh();
                return false;
            });
        }

        n.trigger('init.'+ns, [t]);
    };

    $.extend($.jk.SimpleCaptcha.prototype, {
        allowRefresh: true,
        scriptPath: '/plugins/p_simplacaptcha/init.php',
        numImages: 5,
        introText: "<p>To make sure you are a human, we need you to click on the <span class='captchaText'></span>.</p>",
        refreshButton: "<img src='/plugins/p_simplacaptcha/img/refresh.png' class='refreshButton' alt='Refresh' title='Refresh captcha' />",
        refreshClass: 'refreshCaptcha',
        inputName: 'code',
        introClass: 'captchaIntro',
        textClass: 'captchaText',
        imageBoxClass: 'captchaImages',
        imageClass: 'captchaImage',
        node: null
    });

    $.extend($.jk.SimpleCaptcha.prototype, {

        loadImageData: function(cb) {
            var t = this;
            cb = ($.isFunction(cb))?cb:(function(){});
            $.ajax({
                url: t.scriptPath,
                data: { numImages: t.numImages, captcha_id: t.id},
                type: 'post',
                dataType: 'json',
                success: function(d, s) {
                    if (d && d.images && d.text) {
                        t.data = d;
                        t.node.trigger('dataload.'+ns, [d]);
                        cb(d);
                    } else {
                        t.node.trigger('error.'+ns, ['Invalid data was returned from the server.']);
                        cb(null);
                    }
                },
                error: function(xhr, s) {
                    cb(null);
                    t.node.trigger('error.'+ns, ['There was a serious problem: '+xhr.status]);
                }
            });
        },
        addImagesToUI: function() {
            var t = this;
            t.node.find('.'+t.textClass).text(t.data.text);
            var h = "";
            for (var i=0; i<t.data.images.length; ++i) {
                h += "<img class='"+t.imageClass+"' src='"+t.scriptPath+'?hash='+t.data.images[i]+"&captcha_id="+ t.id+"' alt=''  data-hash='"+t.data.images[i]+"' />";
            }
            t.node.find('.'+t.imageBoxClass).html(h);
            t.node.trigger('ready.'+ns, [t]);
        },
        refresh: function() {
            var t = this;
            t.node.trigger('refresh.'+ns, [t]);
            t.loadImageData(function(d) {
                if (d) { t.addImagesToUI(); }
            });
        }
    });
})(jQuery);